<template>
  <div id="booking-container" class="px-3">
    <div v-if="showModal">
      <BookingModal
        @closed="modalClosed"
        @populate="populateEvents"
        :date="date"
        :booking-time="time"
        :selected="selected"
        :user="user"
      />
    </div>
    <div id="calendar-container">
      <div>
        <v-app id="inspire">
          <v-row>
            <v-col>
              <v-layout wrap>
                <v-flex xs12>
                  <v-sheet height="60">
                    <v-toolbar flat>
                      <v-btn
                        outlined
                        class="mr-4"
                        color="grey darken-2"
                        @click="setToday"
                      >
                        Today
                      </v-btn>
                      <v-btn
                        fab
                        text
                        small
                        color="grey darken-2"
                        @click="$refs.calendar.prev()"
                      >
                        <v-icon small> mdi-chevron-left </v-icon>
                      </v-btn>
                      <v-btn
                        fab
                        text
                        small
                        color="grey darken-2"
                        @click="$refs.calendar.next()"
                      >
                        <v-icon small> mdi-chevron-right </v-icon>
                      </v-btn>
                      <v-toolbar-title v-if="$refs.calendar">
                        {{ $refs.calendar.title }}
                      </v-toolbar-title>
                      <v-spacer></v-spacer>
                      <v-menu bottom right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            outlined
                            color="grey darken-2"
                            v-bind="attrs"
                            v-on="on"
                          >
                            <span>{{ typeToLabel[type] }}</span>
                            <v-icon right> mdi-menu-down </v-icon>
                          </v-btn>
                        </template>
                        <v-list>
                          <v-list-item @click="type = 'day'">
                            <v-list-item-title>Day</v-list-item-title>
                          </v-list-item>
                          <v-list-item @click="type = 'week'">
                            <v-list-item-title>Week</v-list-item-title>
                          </v-list-item>
                          <v-list-item @click="type = 'month'">
                            <v-list-item-title>Month</v-list-item-title>
                          </v-list-item>
                          <v-list-item @click="type = '4day'">
                            <v-list-item-title>4 days</v-list-item-title>
                          </v-list-item>
                        </v-list>
                      </v-menu>
                    </v-toolbar>
                  </v-sheet>
                  <v-sheet height="600">
                    <br />
                    <v-calendar
                      color="#00cc99"
                      ref="calendar"
                      v-model="focus"
                      :type="type"
                      @click:date="dayClicked"
                      @click:day="dayClicked"
                      @click:event="showEvent"
                      @click:more="viewDay"
                      :events="events"
                    ></v-calendar>
                  </v-sheet>
                </v-flex>
              </v-layout>
            </v-col>
          </v-row>
        </v-app>
      </div>
    </div>
  </div>
</template>

<script>
import BookingModal from "./BookingModal";
import booking from "../../controllers/booking.controller";
export default {
  name: "Booking",
  components: { BookingModal },
  data: function () {
    return {
      //all bookings fetched from api
      bookings: [],
      //all events sent as props to calendar
      events: [],
      focus: "",
      showModal: false,
      //the selected event
      selected: null,
      date: null,
      time: null,
      //type of user
      userType: null,
      type: "month",
      typeToLabel: {
        month: "Month",
        week: "Week",
        day: "Day",
        "4day": "4 Days",
      },
    };
  },
  computed: {
    user() {
      return this.$store.getters.getAuthUser;
    },
  },
  methods: {
    async addBooking() {},
    modalClosed: function (data) {
      if (data) {
        this.venues = data;
      }
      this.selected = null;
      this.showModal = false;
    },
    dayClicked(params) {
      this.date = params.date;
      this.time = new Date().toLocaleTimeString("en-GB", { hour12: false });
      this.showModal = true;
    },
    setToday() {
      this.focus = "";
    },
    viewDay({ date }) {
      this.focus = date;
      this.type = "day";
    },
    showEvent(params) {
      this.date = params.day.date;
      this.selected = params.event;
      this.showModal = true;
    },
    async populateEvents() {
      try {
        if (this.user.role == "Trainer") {
          this.bookings = await booking.getTrainerBookings(this.user.trainerId);
        } else {
          this.bookings = await booking.getAllBookings();
        }
        if (this.bookings.length > 0) {
          this.events = this.bookings.map((booking) => {
            const offset = new Date(booking.sessionDate).getTimezoneOffset();
            const sessionDate = new Date(booking.sessionDate);
            sessionDate.setMinutes(sessionDate.getMinutes() - offset);

            let endTime = new Date(sessionDate);
            endTime.setHours(endTime.getHours() + 1);
            return {
              name: booking.description,
              start: sessionDate.toISOString().substring(0, 16),
              end: endTime.toISOString().substring(0, 16),
              color:
                booking.status == 0
                  ? "blue"
                  : booking.status == 1
                  ? "green"
                  : "red",
              venueId: booking.venueId,
              clientId: booking.clientId,
              bookingId: booking.bookingId,
              status: booking.status,
              trainerId: booking.trainerId,
            };
          });
        }
        this.$emit("onNewBooking");
      } catch (e) {
        console.log(e);
      }
    },
  },
  async created() {
    await this.populateEvents();
  },
};
</script>

<style>
</style>